DROP TABLE IF EXISTS sacoche_geo_departement;

CREATE TABLE sacoche_geo_departement (
  geo_departement_id     SMALLINT(4) UNSIGNED                NOT NULL DEFAULT 0,
  geo_academie_id        TINYINT(2)  UNSIGNED                NOT NULL DEFAULT 0,
  geo_departement_numero CHAR(4)     COLLATE utf8_unicode_ci NOT NULL DEFAULT "" ,
  geo_departement_nom    VARCHAR(40) COLLATE utf8_unicode_ci NOT NULL DEFAULT "" ,
  PRIMARY KEY (geo_departement_id),
  KEY geo_academie_id (geo_academie_id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

ALTER TABLE sacoche_geo_departement DISABLE KEYS;

INSERT INTO sacoche_geo_departement VALUES
(  0, 99,    "" , "Sans Objet"),
(  1, 10, " 01" , "Ain"),
(  2, 20, " 02" , "Aisne"),
(  3,  6, " 03" , "Allier"),
(  4,  2, " 04" , "Alpes-de-Haute-Provence"),
(  5,  2, " 05" , "Hautes-Alpes"),
(  6, 23, " 06" , "Alpes-Maritimes"),
(  7,  8, " 07" , "Ardèche"),
(  8, 19, " 08" , "Ardennes"),
(  9, 16, " 09" , "Ariège"),
( 10, 19, " 10" , "Aube"),
( 11, 11, " 11" , "Aude"),
( 12, 16, " 12" , "Aveyron"),
( 13,  2, " 13" , "Bouches-du-Rhône"),
( 14,  5, " 14" , "Calvados"),
( 15,  6, " 15" , "Cantal"),
( 16, 13, " 16" , "Charente"),
( 17, 13, " 17" , "Charente-Maritime"),
( 18, 18, " 18" , "Cher"),
( 19, 22, " 19" , "Corrèze"),
( 21,  7, " 21" , "Côte-d'Or"),
( 22, 14, " 22" , "Côtes-d'Armor"),
( 23, 22, " 23" , "Creuse"),
( 24,  4, " 24" , "Dordogne"),
( 25,  3, " 25" , "Doubs"),
( 26,  8, " 26" , "Drôme"),
( 27, 21, " 27" , "Eure"),
( 28, 18, " 28" , "Eure-et-Loir"),
( 29, 14, " 29" , "Finistère"),
( 30, 11, " 30" , "Gard"),
( 31, 16, " 31" , "Haute-Garonne"),
( 32, 16, " 32" , "Gers"),
( 33,  4, " 33" , "Gironde"),
( 34, 11, " 34" , "Hérault"),
( 35, 14, " 35" , "Ille-et-Vilaine"),
( 36, 18, " 36" , "Indre"),
( 37, 18, " 37" , "Indre-et-Loire"),
( 38,  8, " 38" , "Isère"),
( 39,  3, " 39" , "Jura"),
( 40,  4, " 40" , "Landes"),
( 41, 18, " 41" , "Loir-et-Cher"),
( 42, 10, " 42" , "Loire"),
( 43,  6, " 43" , "Haute-Loire"),
( 44, 17, " 44" , "Loire-Atlantique"),
( 45, 18, " 45" , "Loiret"),
( 46, 16, " 46" , "Lot"),
( 47,  4, " 47" , "Lot-et-Garonne"),
( 48, 11, " 48" , "Lozère"),
( 49, 17, " 49" , "Maine-et-Loire"),
( 50,  5, " 50" , "Manche"),
( 51, 19, " 51" , "Marne"),
( 52, 19, " 52" , "Haute-Marne"),
( 53, 17, " 53" , "Mayenne"),
( 54, 12, " 54" , "Meurthe-et-Moselle"),
( 55, 12, " 55" , "Meuse"),
( 56, 14, " 56" , "Morbihan"),
( 57, 12, " 57" , "Moselle"),
( 58,  7, " 58" , "Nièvre"),
( 59,  9, " 59" , "Nord"),
( 60, 20, " 60" , "Oise"),
( 61,  5, " 61" , "Orne"),
( 62,  9, " 62" , "Pas-de-Calais"),
( 63,  6, " 63" , "Puy-de-Dôme"),
( 64,  4, " 64" , "Pyrénées-Atlantiques"),
( 65, 16, " 65" , "Hautes-Pyrénées"),
( 66, 11, " 66" , "Pyrénées-Orientales"),
( 67, 15, " 67" , "Bas-Rhin"),
( 68, 15, " 68" , "Haut-Rhin"),
( 69, 10, " 69" , "Rhône"),
( 70,  3, " 70" , "Haute-Saône"),
( 71,  7, " 71" , "Saône-et-Loire"),
( 72, 17, " 72" , "Sarthe"),
( 73,  8, " 73" , "Savoie"),
( 74,  8, " 74" , "Haute-Savoie"),
( 75,  1, " 75" , "Paris"),
( 76, 21, " 76" , "Seine-Maritime"),
( 77, 24, " 77" , "Seine-et-Marne"),
( 78, 25, " 78" , "Yvelines"),
( 79, 13, " 79" , "Deux-Sèvres"),
( 80, 20, " 80" , "Somme"),
( 81, 16, " 81" , "Tarn"),
( 82, 16, " 82" , "Tarn-et-Garonne"),
( 83, 23, " 83" , "Var"),
( 84,  2, " 84" , "Vaucluse"),
( 85, 17, " 85" , "Vendée"),
( 86, 13, " 86" , "Vienne"),
( 87, 22, " 87" , "Haute-Vienne"),
( 88, 12, " 88" , "Vosges"),
( 89,  7, " 89" , "Yonne"),
( 90,  3, " 90" , "Territoire de Belfort"),
( 91, 25, " 91" , "Essonne"),
( 92, 25, " 92" , "Hauts-de-Seine"),
( 93, 24, " 93" , "Seine-Saint-Denis"),
( 94, 24, " 94" , "Val-de-Marne"),
( 95, 25, " 95" , "Val-d'Oise"),
(620, 27, " 20A", "Corse-du-Sud"),
(720, 27, " 20B", "Haute-Corse"),
(971, 32, "971" , "Guadeloupe"),
(972, 31, "972" , "Martinique"),
(973, 33, "973" , "Guyane française"),
(974, 28, "974" , "La Réunion"),
(975, 44, "975" , "Saint-Pierre-et-Miquelon"),
(976, 43, "985" , "Mayotte"),
(983, 40, "988" , "Nouvelle-Calédonie"),
(984, 41, "987" , "Polynésie Française"),
(987, 42, "986" , "Wallis-et-Futuna"),
(989, 99, "984" , "Terres Australes, Antarctique Française");

ALTER TABLE sacoche_geo_departement ENABLE KEYS;
